# RAR-Index
It's some project for my school which is supposed to index _rar_-archives and make them searchable over a very ugly web frontend.

## Features
- Add and delete archives
  - edit their labels (as their owner)
- search through archives based on:
  - Keywords
  - Category
- log into a user account
  - log out
- view the user details
  - update the display name and password

## Downloading
```bash
git clone https://git.marcelsite.com/marcel/rar-index-py
cd rar-index-py
```

## Usage
### Baremetal
Install the dependencies:
```bash
pip install -r requirements.txt
```
Edit the configuration:
```bash
cd flask
cp example.config.py config.py
$EDITOR config.py
```
Start the server:
```bash
python app.py
```
This will start the server in a development environment. The Docker image is built with uWSGI for production use.

### Docker
I recommend just using the provided package on this server:
```yml
version: "2.4"
services:
  db:
    image: mariadb:latest
    environment:
      - MARIADB_DATABASE=rar_index
      - MARIADB_USER=rar_index_app
      - MARIADB_PASSWORD=password
      - MYSQL_ROOT_PASSWORD=secretadminpassword
    volumes:
      - db-data:/var/lib/mysql
    restart: unless-stopped

  app:
    image: git.marcelsite.com/marcel/rar-index-app
    container_name: rar-index-app
    environment:
      - MARIADB_USER=rar_index_app
      - MARIADB_HOST=db
      - MARIADB_PASSWORD=password
    depends_on:
      - db
    ports:
      - 5000:5000
    restart: unless-stopped

volumes:
  db-data:

```
This will make the server accessible from anywhere over port 5000.

## Contributing
I don't recommend wasting your time on this project. It is only created to get a (hopefully) good grade in school.